// import * as GC from '@grapecity/spread-sheets';
// import { defaultG4MUITheme } from '@highradius/g4_ui_components/lib/components/theme/defaultTheme';
function forecastModelCell(){
	this.typeName = "forecastModelCell";
}
const DEFAULT_HEIGHT = 28;
const DEFAULT_WIDTH = 180;
const textPrototype = GC.Spread.Sheets.CellTypes.Text.prototype;
forecastModelCell.prototype = new GC.Spread.Sheets.CellTypes.Base();
let _oldPaintFn = forecastModelCell.prototype.paint;
forecastModelCell.prototype.paint = function (
  ctx,
  value,
  x,
  y,
  w,
  h,
  style,
  options,) {
  // Paints a cell on the canvas.
  style.hAlign = GC.Spread.Sheets.HorizontalAlign.left;
  style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
  style.cellPadding = "0 0 0 10"
  //style.font = `${defaultG4MUITheme.typography.body1.fontStyle} ${defaultG4MUITheme.typography.body1.fontWeight} ${defaultG4MUITheme.typography.body1.fontSize} ${defaultG4MUITheme.typography.body1.fontFamily}`;

  if (value && typeof value === "object") {
    let indentaion = ((value.depth || 0) + 1) * 10;
    style.cellPadding = `0 0 0 ${indentaion}`

    const existingStyle = value.style;
    if (existingStyle) {
      let format = existingStyle.bold ? 'bold ' : '';
      format += existingStyle.italic ? 'italic ' : '';
      format += existingStyle.fontSize ? existingStyle.fontSize + 'px' : 14;
      //style.font = `${format} ${defaultG4MUITheme.typography.body1.fontFamily}`;
      style.foreColor = existingStyle.fontColor;
      style.backColor = existingStyle.fillColor;
    }
    _oldPaintFn.apply(
      this,
      [ctx,
        value.content,
        x,
        y,
        w,
        h,
        style,
        options]
    );
  }
  else {
    // default operation
    style.cellPadding = "0 0 0 0"
    style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
    _oldPaintFn.apply(this, arguments);
  }
};

forecastModelCell.prototype.setEditorValue = function (editorContext, value, context) {
  var actualVal = context.sheet.getValue(context.row, context.col);
  if (actualVal && typeof actualVal === "object") {
    GC.Spread.Sheets.CellTypes.Text.prototype.setEditorValue.call(
      this,
      editorContext,
      actualVal.content,
      context
    );
  } else {
    // default operation
    textPrototype.setEditorValue.apply(
      this,
      arguments
    );
  }
};

forecastModelCell.prototype.getEditorValue = function (editorContext, context) {
  var actualVal = context.sheet.getValue(context.row, context.col);
  var editorVal = textPrototype.getEditorValue.apply(
    this,
    arguments
  );
  if (actualVal && typeof actualVal === "object") {
    actualVal.content = editorVal;
    return actualVal;
  } else {
    // default operation
    return editorVal;
  }
};

// const _oldWidthFn = forecastModelCell.prototype.getAutoFitWidth;
// forecastModelCell.prototype.getAutoFitWidth = function () {
//   let minWidth = DEFAULT_WIDTH;
//   let width = _oldWidthFn.apply(this, arguments);
//   return Math.max(minWidth, width);
// };

forecastModelCell.prototype.getAutoFitHeight = function (val, text, cellStyle, zoomFactor,
  context) {
  let height = DEFAULT_HEIGHT;
  const existingStyle = val && val.style;
  if (existingStyle && existingStyle.fontSize) {
    let fontSize = existingStyle.fontSize;
    return fontSize > 32 ? 80 : fontSize > 23 ? 35 : height;
  }
  return height;

}

forecastModelCell.prototype.format = function (value, format, formattedData, context)
{
	//console.log(value);
  if(value && value.content) {
    return JSON.stringify(value);
  } else {
      return value;
  }
}

//const forecastModelCell.prototype = forecastModelCell.prototype;

let forecastModelColumn = { cellType: forecastModelCell };

// const getForecastModelColumns = (colCount) => {
//   const cols = [];
//   for (let i = 0; i < colCount; i++) {
//     cols.push(forecastModelColumn);
//   }
//   return cols;
// }
var spreadNS = GC.Spread.Sheets;

window.onload = function () {
    var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1});
    initSpread(spread);
};

function initSpread(spread) {
    var sheet = spread.getSheet(0);
	sheet.options.clipBoardOptions = GC.Spread.Sheets.ClipboardPasteOptions.values;

    spread.suspendPaint();

    sheet.name("Copy Paste");
    initData(sheet);

    spread.resumePaint();
};

function initData(sheet) {
    // sheet.setArray(0, 0, [[123456789.123, 123456789],]);

    // for (var c = 0; c < 2; c++) {
    //     sheet.setColumnWidth(c, 200);
    // }

    // sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
    
    // sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
    // sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
	// sheet.getRange(0, 0, 10, 10).formatter(new forecastModelCell());
	sheet.fromJSON(getTempData());
	//console.log(getTempData());
	for(let i =0;i<sheet.getColumnCount();i++)
	{
		for(let j=0;j<sheet.getRowCount();j++)
		{
			sheet.getCell(i,j).cellType(new forecastModelCell());
		}
	}
};



function getTempData() {
	var people = {
	  data: {
		dataTable: {
		  "0": {
			"0": {
			  value: {
				content: "Cashflow Category",
				extracontent: {
				  id: "123",
				}
			  },
			},
			  "1": {
				value: {
				  content: "Company",
				  extracontent: {
					id: true
				  }
				},
			  },
				"2": {
				  value: {
					content: "W -2"
				  },
				},
				"3": {
				  value: {
					content: "W -1"
				  }
				},
				"4": {
				  value: { content: "D 1" }
				},
				"5": {
				  value: { content: "M 1" }
				},
				"6": {
				  value: { content: "W 1" }
				},
				"7": {
				  value: { content: "=TOTAL()" }
				}
				}
				
			  }
			}  
	  };
	return people;
  }